#include    "ti83plus.inc"
#include    "mirage.inc"
#define aigame          appbackupscreen
#define aipause         appbackupscreen + 1
#define score           appbackupscreen + 2       ;right wins if score is 10, left wins if score is 0
#define pointsscored    appbackupscreen + 3
#define p1y             appbackupscreen + 4
#define p1x             appbackupscreen + 5         ;py = IX
#define p1yv            appbackupscreen + 6         ;px = IX+1
#define p1xv            appbackupscreen + 7         ;pyv = IX+2
#define p2y             appbackupscreen + 8         ;pxv = IX+3
#define p2x             appbackupscreen + 9
#define p2yv            appbackupscreen + 10
#define p2xv            appbackupscreen + 11
#define bally           appbackupscreen + 12
#define ballx           appbackupscreen + 13
#define ballyv          appbackupscreen + 14
#define ballxv          appbackupscreen + 15
#define playflag        appbackupscreen + 16            ;fInPlay
#define StopFlag        appbackupscreen + 17
#define scoringRun      appbackupscreen + 18
#define PTouchFlag      appbackupscreen + 19            ;fP1Touched, fP2Touched
#define jump1           appbackupscreen + 20        ;jump = IX + 16
#define timer1          appbackupscreen + 21        ;timer = IX + 17
#define hit1            appbackupscreen + 22        ;hit = IX + 18
#define jump2           appbackupscreen + 24
#define timer2          appbackupscreen + 25
#define hit2            appbackupscreen + 26 
#define ballpause       appbackupscreen + 28 
#define ballcury        appbackupscreen + 29
#define ballcurx        appbackupscreen + 30
#define ballhit         appbackupscreen + 31 
#define ballnexty       appbackupscreen + 32
#define ballnextx       appbackupscreen + 33  
#define hitx            appbackupscreen + 34
#define hity            appbackupscreen + 35
#define balljump        appbackupscreen + 36
#define ballside        appbackupscreen + 37
#define ballxpause      appbackupscreen + 38
    .org    $9D95
    ret
    .db 1
    
    .db %00001111, %11110000
    .db %00011000, %00101000
    .db %00100000, %11000100
    .db %01111011, %11100110
    .db %11100011, %11110111
    .db %11100011, %11100011
    .db %11000001, %11100011
    .db %10000000, %00000011
    .db %10000010, %00100011
    .db %10111100, %00011111
    .db %10111100, %00011111
    .db %11111110, %00111111
    .db %01111111, %11111110
    .db %00111111, %11111100
    .db %00011111, %11111000
    
    .db "Slime Soccer",0    

;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::menu:::::::::::::::::::::::::::::::::::::::::::::
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
menu:                     ;centertext - Centers text (horizontally) on the screen and displays 
    xor A
    ld (pointsscored), A
    ld (aigame), A
    CALL clrgrphbuf             ; - Input  a = penrow to display at
    CALL drawbottom             ; -        hl -> text
    CALL drawnet
    xor A
    LD HL, menumsg
    call centertext
    LD A, 8
    LD HL, menumsg2   
    call centertext
    LD A, 16
    LD HL, menumsg3  
    call centertext
    LD A, 24
    LD HL, menumsg4  
    call centertext
    LD A, 32
    LD HL, menumsg5 
    call centertext    
menuloop:
    ld A, $BF
    call directin
    CP $DF            ;2nd
    JP Z, start
    CP $BF           ;mode
    ret z
    ld A, $DF
    call directin
    cp $7F              ;alpha
    jp z, aistart
    jr menuloop
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;::::::::::::::::::::::::::::::::::START GAME::::::::::::::::::::::::::::::::::::::::::::::::::::::
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
aistart: 
    call clrgrphbuf
    ld A, 8
    ld HL, aimsg
    call centertext

    ld A, 1
    ld (aigame), A
    xor a
aidiffloop: 
    push af
    ld H, 0
    inc a
    ld L, a
    call dispHL
    bcall(_getcsc)
    cp skUp
    jr z, aiup
    cp skDown
    jr z, aidown
    cp skEnter
    jr z, findaipause
    cp skDel
    call z, quittoshell
    cp sk2nd
    jr z, findaipause
    pop af
    jr aidiffloop
aidown:
    pop af
    and A
    jr z, aidiffloop
    dec A
    jr aidiffloop
aiup:
    pop af
    cp 4
    jr z, aidiffloop
    inc a
    jr aidiffloop
findaipause:
    pop af
    ld HL, xpausetable+5
    and A
    jr z, skipailoop
    ld b, a
aipauseloop:
    inc L
    djnz aipauseloop
skipailoop:
    ld A, (HL)
    ld (aipause), A
    
start:
    ld A, %01111111
    ld (ballxpause), A
    ld A, 5
    ld (score), A
restartgoal: 
    CALL clrgrphbuf   
    call drawnet
    xor A
    ld (ballxv), A
    ld (p2yv), A
    ld (p1yv), A
    ld (timer1), A
    ld (timer2), A
    ld (p1xv), A
    ld (p2xv), A
    ld (balljump), A
    inc A               ;ld A, 1
    ld (ballyv), A
    ld (ballpause), A
    ld (playflag), A
    LD A, 49
    LD (p1y), A         ;floor is at 47+8 = 55
    LD (p2y), A
    dec A               ;ld A, 48
    LD (ballx), A  
    ld (ballcurx), A  
    LD A, 16
    LD (p1x), A
    LD A, 72
    LD (p2x), A
    LD A, 35
    LD (bally), A
    ld (ballcury), A
    call drawscore
    LD DE, (p1y)
    ld HL, whitespriteleft
    call displayplayer
    ld DE, (p2y)
    ld HL, blackspriteleft     
    call displayplayer
    call dispball
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;RUN;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
run:
    call ifastcopy
    call goball
    
moveSlimers:
    LD DE, (p1y)
    ld HL, whitespriteleft
    call eraseplayer
    ld IX, p1y
    call moveplayer
    
    ;LD IX, p1y still p1y from moveplayer
    LD A, $FE           ;FE is down, FD is left, FB is right, F7 is up
    CALL directin
    bit 1, A             ;$FD = %11111101
    CALL Z, left
    bit 2, A              ;$FB = %11111011
    CALL Z, right
    bit 3, A               ;$F7 = %11110111
    CALL Z, up    
    
    LD DE, (p1y)
    ld HL, whitespriteleft
    call displayplayer
    
    ld HL, blackspriteleft
    ld DE, (p2y)  
    call eraseplayer
    ld IX, p2y
    call moveplayer
    ld A, (aigame)
    and A
    call nz, aintel
    ld A, (aigame)
    and A
    jr nz, p2cont
    LD A, $EF
    CALL directin
    bit 2, A              ;$FB = %11111011
    CALL Z, left
    LD A, $F7
    CALL directin
    bit 3, A               ;$F7 = %11110111
    CALL Z, up
    LD A, $FB
    CALL directin
    bit 2, A              ;$FB = %11111011
    CALL Z, right
p2cont:
    ld DE, (p2y)
    ld HL, blackspriteleft     
    call displayplayer


    LD A, $BF
    CALL directin
    bit 6, A              ;$BF = %10111111
    JP Z, menu  
    bit 7, A              ;$7F = %01111111
    ret Z
    ld A, $FD
    call directin
    cp $FE
    call z, pause
playorstop:
    ld A, (playflag)
    and A
    JP nz, run
goal:
    ld B, 7
goalloop:
    push BC
    ld B, 9
    call delayb
    call goball
    call ifastcopy
    pop BC
    djnz goalloop
    ld hl, score
inc_dec
    dec (hl)
    ld HL, pointsscored
    inc (HL)
    ld A, (score)               ;right wins if score is 10, left wins if score is 0
    and A                       ;cp 0
    jr z, leftwins
    cp 10
    jr z, rightwins   
    call pause
    jp restartgoal 
rightwins:
    call drawtop
    LD HL, rightmsg
    jr winner    
leftwins:
    call drawtop
    ld HL, leftmsg
winner:
    ld A, 10
    call centertext
    jp pause

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::ROUTINES::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Artificial Intelligence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
aintel:
    ld hl, aipause
    rrc (hl)
    ret nc
    ld A, (balljump)
    cp 4
    jr nc, aicont1
    ld A, (ballyv)
    cp 1
    jr nz, aicont1
    ld A, (p2x)
    cp 48
    jr c, aicont1        
    call up
aicont1:    
    ld A, (p2x)
    ld HL, ballx
    cp (HL)
    push AF
    call c, right
    pop AF
    jr c, aicont2
    ld A, (HL)
    cp 30
    call nc, left
aicont2:
    ret
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Ball Routines;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    
goball:
eraseball:                ;erase old sprite
    ld DE, (bally)
    ld HL, ballsprite
    call sprite_and
moveball:
    ld A, (playflag)
    and A
    jr z, balltesty
    ld A, (ballpause)
    and A                   ;cp 0
    jr nz, noresetpause
    ld A,1
    ld (balljump), A
noresetpause:
    rr A
    ld (ballpause), A
    jp nc, dballx           ;only do it if there was a carry
balltesty:                   ;pixeltest   - Returns z = state of pixel (a,e) in graph buffer     
    ld A, (ballyv)
    dec A           ;cp 1
    ld A, (ballcury) 
    jr nz, contytest         ;if dy isn't 1, it is -1 (going up) and move on
    add A, 5                ;account for size of ball
    ld (ballcury), A    
contytest:                  ;test the pixel at (bx+1, cury) and (bx+2, cury)
    dec A                   ;to account for position of ball (if ball goes up, cury-1 will be next pix
    ld E, A                     ;if ball goes down, cury+5-1 will be next pix).
    ld A, (ballx)
    inc A               ;to get center of ball
    call pixtestforhit
    inc A               ;to get center of ball
    call pixtestforhit
    ld A, (ballhit)
    dec A               ;cp 1
    jp nz, endbally
dealwithhity:               ;deal with hit at (hitx, hity)
    ld A, (hity)            ;test if floor hit
    cp 55
    jr nz, testceiling             ;if ball is not on floor, skip this
    ld hl, ballside
    dec (hl)
bouncetheball:
    ld A, -1                   ;if ball is on floor, neg A           
    ld (ballyv), A
    ld A, (balljump)
    ld B, 10
dwhyloop:                   ;deal with hit y loop
    dec A
    cp 1                 ;if (balljump) is 1, don't decrease
    jr z, enddeal
    ld (balljump), A       
    djnz dwhyloop
    jr enddeal
testceiling:    
    ld A, (playflag)
    and a
    jr z, enddeal
    ld A, (hity) 
    cp 9
    jr nc, hiphip
    ld A, 1
    ld (ballyv), A
    ld A, -2
    ld (balljump), A
    jr enddeal
hiphip:
    ld A, (bally)
    cp 8
    jp c, maybebounce
    cp 88
    jp nc, maybebounce
hityhity:
    ld A, (ballyv)
    neg
    ld (ballyv), A
    ld A, (balljump)
    inc A
    ld L, A
    ld A, (IX+16)
    neg
    sra A
    add A, L
    ld (balljump), A  
    jp enddeal      
maybebounce:
    ld A, (ballx)
    sub 39  ;cp 39
    jr z, bouncetheball
    inc A   ;cp 40
    jr z, bouncetheball
enddeal:    
    xor a
    ld (ballhit), A
endbally:
    ld HL, bally
    ld A, (ballyv)
    add A, (HL)             ;moveball
    ld (bally), A
    ld (ballcury), A
    ld A, (ballyv)
    cp 1                    ;cp ballyv with 1    
    jr nz, contbally        ;
    ld A, (balljump)        ;if ball is going down,
    inc A                   ;increase the ball jump
    call getballpause
    jr dballx
contbally:                  ;ball going up, decrease speed
    ld A, (balljump)        ;if ball is going down, do this
    dec A                   ;decrease the ball jump
    call getballpause
    ld A, (balljump)
    cp 1
    jp nz, dballx
    ld A, 1
    ld (ballyv), A
dballx:
    ld A, (playflag)
    and A
    jp z, skipballxpause
balltestx:
    ld A, (bally)           ;testrightside
    ld E, A
    ld A, (ballx)
    dec A                   ;to get right side
    inc E
    call pixtestforhit
    inc E
    call pixtestforhit
    ld A, (ballhit)
    cp 1
    jr z, dealwithhitx
    ld A, (bally)           ;testleftside:
    ld E, A
    ld A, (ballx)
    add A, 4                ;to get left side
    inc E
    call pixtestforhit
    inc E
    call pixtestforhit
    ld A, (ballhit)
    cp 1
    jr nz, endballx
dealwithhitx:
    ld A, (ballx)
    cp 9                ;if ball in goal, don't change direction
    jp c, endballx
    cp 84
    jp nc, endballx
    ld B, A
    ld A, (hitx)
    cp B                ;if left hit, there wont be a carry
    jp nc, lefthit
    ld A, 1
    jr enddwhx
lefthit:    
    ld A, -1
enddwhx:
    ld (ballxv), A
    ld A, 1
    ld (ballyv), A    
    ld A, (balljump)
    add A, 3
    ld (balljump), A
    ld A, 4
    ld (ballside), A
    ld IX, p1y
    call testphit
    ld IX, p2y
    call testphit    
endballx:
    ld A, (ballxpause)
    rrc A
    ld (ballxpause), A
    jr nc, endmoveball
    ld A, (ballside)
    and A
    jp nz, skipballxpause
    xor A
    ld (ballxv), A
    jr endmoveball    
skipballxpause:
    ld HL, ballx
    ld A, (ballxv)
    add A, (HL)
    and a
    jr z, hitwall
    cp 93
    jr z, hitwall
    ld (ballx), A
    ld (ballcurx), A
    jr endmoveball
hitwall:
    ld A, (ballxv)
    neg
    ld (ballxv), A
endmoveball:    
    call dispball
goaltest:
    ld A, (bally)
    cp 39
    ret c
    ld A, (ballx)
    cp 85
    jr nc, rgoaly    
    cp 9
    ret nc 
lgoaly:     ;right wins if score is 10, left wins if score is 0
    ld A, %00110100     ;ld A, 'inc (hl)'
    ld (inc_dec), A
    xor A
    ld (playflag), A
    ret
rgoaly:
    ld A, %00110101     ;ld A, 'dec (hl)'
    ld (inc_dec), A 
    xor A
    ld (playflag), A  
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Ball Sub-routines;;;;;;;
testphit:
    ld A, (ballx)
    ld D, 2
ihitloop:
    ld C, A
    ld B, 10
hitloop:
    dec B
    ld A, (IX+1)        ;(x value + B) cp (ballx)
    add A, B
    cp C
    jr z, hithithit
    inc B
    djnz hitloop
    ld A, C             ;test both sides of ball
    add A, 4
    dec D
    jr nz, ihitloop
    ret
hithithit:
    ld HL, xpausetable
    xor A
    cp B
    jr z, hitend
    dec HL
hithitloop:
    inc HL
    djnz hithitloop
hitend:   
    ld A, (HL)
    ld (ballxpause), A
    ret
  
getballpause:
    ld (balljump), A
    srl A                   ;divide (balljump) by four to account for size of table
    srl A                    ;allows ball to go 13*4=52 high
    and A                   ;cp 0                    
    ld B, A
    ld HL, balloffsettable
    jr z, skipballloop      ;if (balljump)/2 = 0, skip inc loop
ballloop1:                  ;loops (balljump) number of times
    inc HL                  ;increases IX to jump to right number
    djnz ballloop1
skipballloop:
    ld A, (HL)
    ld (ballpause), A
    ret           
   
pixtestforhit:         ;pixel test at (a,e)
    ld D, A             ;save a and e b/c of pixeltest
    push DE             ;can't push AF b/c we care about F from pixeltest
    call pixeltest
    pop DE
    ld A, D
    ret z               ;if yes, set hit
    
    ld (hitx), A
    push AF             ;set hit
    ld A, 1
    ld (ballhit), A
    ld A, E
    ld (hity), A
    pop AF
    ret     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;PLAYER ROUTINES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
moveplayer:         ;py = + 0, px = + 1, pyv = + 2, pxv = + 3
    LD A, (IX+1)     ;Change the x
    ADD A, (IX+3)    
    cp 7
    JR Z, moveply
    CP 79
    JR Z, moveply
    LD (IX+1), A
    XOR A
    ld (IX+3), A    ;jump = IX + 16 = height of jump
moveply:            ;timer = IX + 17 = pause value
    LD A, (IX+2)    ;hit = IX + 18 = abs(jumpheight)/2 
    and A            ;if dy is 0, move on
    ret Z  
    ld A, (IX+17)
    rr A
    ld (IX+17), A
    ret nc
    
    ld A, (IX+16) 
    bit 7, A
    jr z, skiplooppy1       ; jump height is negative, abs;
looppy1:                ;takes abs of jump height
    neg
skiplooppy1:    
    srl A               ;divide by two to account for size of table
    ld HL, balloffsettable    
    ld D, 0
    ld E, A    
    add HL, DE          ;add (balloffsettable) and (abs(jumpheight)/2)
    
    ld A, (HL)          ;HL now points to pause value
    ld (IX+17), A

    ld A, (IX+16)
    dec A
    ld (IX+16), A
    cp -15
    jr z, endjump
    and A           ;cp 0
    jp nz, contpy   ;if jump height is 0, turn em around 
    ld A, 1
    ld (IX+2), A 
    ret             ;don't add if height is 0
contpy:                                
    ld A, (IX)
    ADD A, (IX+2)
    LD (IX), A     ;otherwise add em up and put it back in
    RET
endjump:
    xor A
    ld (IX+2), A
    ld (IX+16), A
    ret
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;INPUT Response;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
up:                     ;works - deals with an up key press event
    LD A, (IX+2)
    and A
    ret NZ
    dec a
    LD (IX+2), A
    ld A, 15
    ld (IX+16),A
    ld A, 1
    ld (IX+17),A
    RET    
    
left:                   ;works - deals with left key press event
    push AF             ;input: IX - y value for player
    LD A, -1
    LD (IX + 3), A
    pop AF
    RET
    
right:                  ;works - deals with right key press event
    push AF             ;input: IX - y value for player
    LD A, 1
    LD (IX + 3), A
    pop AF
    RET 
    
pause:              ;works - Pauses until enter is pressed
    ld A, $FD
    call directin
    CP $FE
    ret z
    ld A, $BF
    call directin
    cp $DF
    ret z
    cp $7F
    call z, quittoshell
    cp $BF
    jr nz, pause
frompausetomenu:
    pop HL
    jp menu

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;DISPLAYING STUFF;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
drawscore:
    call drawtop
    ld A, (score)
    ld B, A
countscoreup:
    ld A, (score)
    sub B                     ;get difference
    neg
    ld C, A
    add A, A
    add A, A
    add A, C
    add A, 91
    ld D, A                  ;x-value
    ld E, 3
    ld HL, scoresprite
    push BC
    call sprite_and
    pop BC
    dec B       ;left person wins if score is 10, right wins if score is 0
    jr z, scorecont    
    jr countscoreup    
scorecont:
    ld A, (score)
    ld B, A
countscoredown:
    ld A, (score)
    sub B
    neg
    ld C, A
    add A, A
    add A, A
    add A, C 
    ld D, A
    ld E, 3
    ld HL, scoresprite
    push BC
    call sprite_and
    pop BC
    inc B 
    ld A, B
    cp 10
    ret z
    jr countscoredown
                 
drawtop:                 ;works - draws black top
    LD HL, $FF 
    LD (Plotsscreen), HL
    LD BC, 107
    LD DE, PlotSScreen + 1
    LD HL, PlotSScreen
    LDIR
drawbottom:                 ;works - draws black bottom
    LD HL, $FF 
    LD (Plotsscreen + 660), HL
    LD BC, 107
    LD DE, PlotSScreen + 661
    LD HL, PlotSScreen +660
    LDIR
    jr jump_fast_copy

drawnet:                    ;works - draws the net
    ld DE, 40
    ld HL, leftgoal
    Call sprite_or
    ld DE, $5828
    ld HL, rightgoal
    call sprite_or
    jr jump_fast_copy
    
clrgrphbuf:
    LD BC, 767
    LD HL, $00
    LD (PlotSScreen), HL
    LD DE, PlotSScreen + 1
    LD HL, PlotSScreen
    LDIR
jump_fast_copy:
    jp ifastcopy 

spriteadjust:
    ld A, D
    add A, 8
    ld D, A
    inc e
    inc e
    ld HL, spriteright
    ret   
    
dispball:               ;disp ball
    ld DE, (bally)
    ld HL, ballsprite
    jr sprite_or
    
displayplayer:    
    push DE
    call sprite_or
    pop DE
    call spriteadjust
    ;jp sprite_or 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    
; The Best Damn Sprite Routine Period (OR Version)
; 
; AUTHOR: Sean McLaughlin (sigma_zk@yahoo.com)
;
; DESCRIPTION:
;   ORs a sprite to PlotSScreen with clipping.
;
; INPUT:
;   D   Abscissa, x
;   E   Ordinate, y
;   HL  Pointer to start of sprite data:
;       number of rows; sprite row 1; sprite row 2; et cetera.
; DESTROYS:
;   AF BC DE HL IX
;   Interrupts are disabled
;
#define O_PIXEL_SHIFT   .DB $CB,$21,$17     ; SLA C\ RLA
Sprite_or:
    LD  B,(HL)          ;B is now # of rows
    LD  A,D             ;A is now x value 
_DoSprite:
    DI
    INC HL              ;HL is now sprite data
    PUSH    HL
    SLA E               ;
    SLA E               ;essentially multiplies E*4
    LD  H,0
    LD  L,E
    LD  D,H
    ADD HL,HL           ;now double E
    ADD HL,DE           ;now (E*4)*3 in HL
    LD  E,A             ;X value into E
    SRA E               ;
    SRA E
    SRA E               ;essentially E/8
    JP  P,_Pos          ;????
    DEC D               ;D now -1
_Pos:
    ADD HL,DE           ;HL now final pos
    LD  DE,PlotSScreen  
    ADD HL,DE           ;now on plotsscreen
    POP DE              ;DE now sprite data
    AND 7               ;cp x value with %00000111 (is X a multple of 8)
    LD  (_save),SP
    LD  SP,11           ;save SP
    JR  Z,_Aligned      ;if X is a multiple of 8, sprite already aligned 
    DEC A               ;otherwise 
    LD  C,A             ;(A-1)*3 -> A
    ADD A,A             ;
    ADD A,C             ;Times 3 bc O_PIXEL_SHIFT is three bytes
    LD  (_Jump),A       ;
_Loop:
    LD  A,(DE)          ;put sprite data in A
    LD  C,A             ;into C
    XOR A               ;0 out A
_Jump   =$+1
    JR  $
    O_PIXEL_SHIFT
    O_PIXEL_SHIFT
    O_PIXEL_SHIFT
    O_PIXEL_SHIFT
    O_PIXEL_SHIFT
    O_PIXEL_SHIFT
    O_PIXEL_SHIFT       ;Pixel shift it up
    OR  (HL)            ;Or it up with what is there
_ClipLeft:              
    LD  (HL),A          ;put it in there
    INC HL              ;increase that there output because not perfectly aligned
    LD  A,C             ;put other half in
    OR  (HL)
_ClipRight:
    LD  (HL),A
    INC DE              ;increase data pointer
    ADD HL,SP           ;next row
    DJNZ    _Loop       ;do this for every row of data
_Done:
_save   =$+1
    LD  SP,0
    ei
    RET
_Aligned:
    INC SP
_ALoop:                 ;B is # of rows
    LD  A,(DE)          ;Ld row of sprite info into A   
    OR  (HL)            ;Or it by what is there
    LD  (HL),A          ;Add it into the mem
    INC DE              ;Increase data row
    ADD HL,SP           ;Increase output row
    DJNZ    _ALoop
    JP  _Done




eraseplayer:    
    push DE
    call sprite_and 
    pop DE
    call spriteadjust
    ;jp sprite_and    
; The Best Damn Sprite Routine Period (AND Version)
; 
; AUTHOR: Sean McLaughlin (sigma_zk@yahoo.com)
;
; DESCRIPTION:
;   ANDs a sprite to PlotSScreen with clipping.
;
; INPUT:
;   D   Abscissa
;   E   Ordinate
;   HL  Pointer to start of sprite data:
;       number of rows; sprite row 1; sprite row 2; et cetera.
; DESTROYS:
;   AF BC DE HL IX
;   Interrupts are disabled
;
#define A_PIXEL_SHIFT   .DB $CB,$31,$17     ; SLL C\ RLA
Sprite_AND:
    LD  B,(HL)
    LD  A,D
_DoSpriteand:
    DI
    INC HL
    PUSH    HL
    SLA E
    SLA E
    LD  H,0
    LD  L,E
    LD  D,H
    ADD HL,HL
    ADD HL,DE
    LD  E,A
    SRA E
    SRA E
    SRA E
    JP  P,_Posand
    DEC D
_Posand:
    ADD HL,DE
    LD  DE,PlotSScreen
    ADD HL,DE
    POP DE
    AND 7
    LD  (_saveand),SP
    LD  SP,11
    JR  Z,_Alignedand
    DEC A
    LD  C,A
    ADD A,A
    ADD A,C
    LD  (_Jumpand),A
_Loopand:
    LD  A,(DE)
    CPL
    LD  C,A
    LD  A,$FF
_Jumpand   =$+1
    JR  $
    A_PIXEL_SHIFT
    A_PIXEL_SHIFT
    A_PIXEL_SHIFT
    A_PIXEL_SHIFT
    A_PIXEL_SHIFT
    A_PIXEL_SHIFT
    A_PIXEL_SHIFT
    AND (HL)
_ClipLeftand:
    LD  (HL),A
    INC HL
    LD  A,C
    AND (HL)
_ClipRightand:
    LD  (HL),A
    INC DE
    ADD HL,SP
    DJNZ    _Loopand
_Doneand:
_saveand   =$+1
    LD  SP,0
    ei
    RET
_Alignedand:
    INC SP
_ALoopand:
    LD  A,(DE)
    CPL
    AND (HL)
    LD  (HL),A
    INC DE
    ADD HL,SP
    DJNZ    _ALoopand
    JP  _Doneand
;Number in hl to decimal ASCII
;Thanks to z80 Bits
;inputs:    hl = number to ASCII
;example: hl=300 outputs '00300'
;destroys: af, bc, hl, de used
DispHL:
    bcall(_homeup)
    ld  bc,-10000
    call    Num1
    ld  bc,-1000
    call    Num1
    ld  bc,-100
    call    Num1
    ld  c,-10
    call    Num1
    ld  c,-1
Num1:   ld  a,'0'-1
Num2:   inc a
    add hl,bc
    jr  c,Num2
    sbc hl,bc
    bcall(_PUTC)
    ret
    
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::SPRITES, STRINGS and VARIABLES::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
menumsg:
    .db "Slime Soccer", 0
menumsg2:
    .db "by B Smith", 0
menumsg3:
    .db "2nd-2 Player Start", 0
menumsg4:
    .db "Alpha-AI Start", 0
menumsg5:
    .db "Mode-Quit", 0
rightmsg:
    .db "Right Wins!", 0
leftmsg:
    .db "Left Wins!", 0       
aimsg:
    .db "Set AI Speed", 0
blackspriteleft:
    .db 6
    .db %00001100
    .db %00110011
    .db %01011001
    .db %01111001
    .db %11111100
    .db %11111111
    
spriteright:
    .db 4
    .db %10000000
    .db %10000000
    .db %11000000
    .db %11000000
           
whitespriteleft:
    .db 6
    .db %00001100
    .db %00110011
    .db %01100110
    .db %01100111
    .db %11001111
    .db %11111111
          
leftGoal:
    .db 15
    .db %11111111
    .db %10101010
    .db %11010101
    .db %10101010
    .db %11010101
    .db %10101010
    .db %11010101
    .db %10101010
    .db %11010101
    .db %10101010
    .db %11010101
    .db %10101010
    .db %11010101
    .db %10101010
    .db %11010101
    
rightGoal:
    .db 15
    .db %11111111
    .db %10101011
    .db %01010101
    .db %10101011
    .db %01010101
    .db %10101011
    .db %01010101
    .db %10101011
    .db %01010101
    .db %10101011
    .db %01010101
    .db %10101011
    .db %01010101
    .db %10101011
    .db %01010101
    
scoresprite:
    .db 3
    .db %01110000
    .db %01110000
    .db %01110000
        
ballSprite:
    .db 4
    .db %01100000
    .db %11010000
    .db %11110000
    .db %01100000 

balloffsettable:
    .db %11110000
    .db %11111100
xpausetable:
    .db %11111111
    .db %11011111
    .db %11011101
    .db %10101011
    .db %01010101
    .db %01010101
    .db %01011101
    .db %10111011
    .db %11111011
    .db %11111111

end